#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(float *B0,float *B1,float *B2,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
B0[i] = B2[i]+B2[i]/B2[i]/B2[i];
B1[i] = B2[i];
}
}

void kernel_cpu(float *B0,float *B1,float *B2,int N){
for(int i=0;i<N;i++){
B0[i] = B2[i]+B2[i]/B2[i]/B2[i];
B1[i] = B2[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "468 ");
int size=328326;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
for(int i=0;i<328326;i++){
B0[i] = 91.3719383223+i+1;
B1[i] = 51.032321017+i+1;
B2[i] = 22.9192969904*i+1;
}
float *d_B0;
cudaMalloc((void **)&d_B0,328326*sizeof(float));
cudaMemcpy(d_B0,B0,328326*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,328326*sizeof(float));
cudaMemcpy(d_B1,B1,328326*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,328326*sizeof(float));
cudaMemcpy(d_B2,B2,328326*sizeof(float),cudaMemcpyHostToDevice);
int n = 1283*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_B0,d_B1,d_B2,328326);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(B0,B1,B2,328326);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,328326*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,328326*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,328326*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<328326;i++){
}
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
printf("\n");return 0; }